Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/tests/ICE_RHEO/MY_SRC/icedyn_rhg_eap.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/tests/ICE_RHEO/MY_SRC/icedyn_rhg_eap.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/tests/ICE_RHEO/MY_SRC/icedyn_rhg_eap.F90	(revision 14200)
@@ -1059,13 +1067,13 @@
       ELSE
          DO_2D( 1, 1, 1, 1 )
-            zres(ji,jj) = MAX( ABS( pu(ji,jj) - pub(ji,jj) ) * umask(ji,jj,1), &
-               &               ABS( pv(ji,jj) - pvb(ji,jj) ) * vmask(ji,jj,1) ) * zmsk15(ji,jj)
+            eap_res(ji,jj) = MAX( ABS( pu(ji,jj) - pub(ji,jj) ) * umask(ji,jj,1), &
+               &               ABS( pv(ji,jj) - pvb(ji,jj) ) * vmask(ji,jj,1) ) * aimsk15(ji,jj)
+            ! cut of the boundary of the box (forced velocities)
+            IF (mjg(jj)<=30 .or. mjg(jj)>970 .or. mig(ji)<=30 .or. mig(ji)>970) THEN
+               eap_res(ji,jj) = 0._wp
+            END IF
          END_2D
 
-         ! cut of the boundary of the box (forced velocities)
-         IF (mjg(jj)<=30 .or. mjg(jj)>970 .or. mig(ji)<=30 .or. mig(ji)>970) THEN
-            zres(ji,jj) = 0._wp
-         END IF
-         zresm = MAXVAL( zres )
+         zresm = MAXVAL( eap_res )
          CALL mpp_max( 'icedyn_rhg_evp', zresm )   ! max over the global domain
       ENDIF
@@ -1077,6 +1085,6 @@
          IF( kt == nitend )   istatus = NF90_CLOSE(ncvgid)
       ENDIF
-      
-   END SUBROUTINE rhg_cvg
+
+   END SUBROUTINE rhg_cvg_eap
 
 
@@ -1085,5 +1093,5 @@
       !!---------------------------------------------------------------------
       !!                   ***  SUBROUTINE update_stress_rdg  ***
-      !!                     
+      !!
       !! ** Purpose :   Updates the stress depending on values of strain rate and structure
       !!                tensor and for the last subcycle step it computes closing and sliding rate
@@ -1098,30 +1106,28 @@
       INTEGER  ::   kx ,ky, ka
 
-      REAL(wp) ::   zstemp11r, zstemp12r, zstemp22r   
-      REAL(wp) ::   zstemp11s, zstemp12s, zstemp22s 
-      REAL(wp) ::   za22, zQd11Qd11, zQd11Qd12, zQd12Qd12 
-      REAL(wp) ::   zQ11Q11, zQ11Q12, zQ12Q12 
-      REAL(wp) ::   zdtemp11, zdtemp12, zdtemp22 
-      REAL(wp) ::   zrotstemp11r, zrotstemp12r, zrotstemp22r   
+      REAL(wp) ::   zstemp11r, zstemp12r, zstemp22r
+      REAL(wp) ::   zstemp11s, zstemp12s, zstemp22s
+      REAL(wp) ::   za22, zQd11Qd11, zQd11Qd12, zQd12Qd12
+      REAL(wp) ::   zQ11Q11, zQ11Q12, zQ12Q12
+      REAL(wp) ::   zdtemp11, zdtemp12, zdtemp22
+      REAL(wp) ::   zrotstemp11r, zrotstemp12r, zrotstemp22r
       REAL(wp) ::   zrotstemp11s, zrotstemp12s, zrotstemp22s
-      REAL(wp) ::   zsig11, zsig12, zsig22 
-      REAL(wp) ::   zsgprm11, zsgprm12, zsgprm22 
-      REAL(wp) ::   zinvstressconviso 
-      REAL(wp) ::   zAngle_denom_gamma,  zAngle_denom_alpha 
-      REAL(wp) ::   zTany_1, zTany_2 
-      REAL(wp) ::   zx, zy, zdx, zdy, zda, zkxw, kyw, kaw
-      REAL(wp) ::   zinvdx, zinvdy, zinvda   
-      REAL(wp) ::   zdtemp1, zdtemp2, zatempprime, zinvsin
-
-      REAL(wp), PARAMETER ::   kfriction = 0.45_wp
-      !!---------------------------------------------------------------------
+      REAL(wp) ::   zsig11, zsig12, zsig22
+      REAL(wp) ::   zsgprm11, zsgprm12, zsgprm22
+      REAL(wp) ::   zAngle_denom_gamma,  zAngle_denom_alpha
+      REAL(wp) ::   zTany_1, zTany_2
+      REAL(wp) ::   zx, zy, zkxw, kyw, kaw
+      REAL(wp) ::   zinvdx, zinvdy, zinvda
+      REAL(wp) ::   zdtemp1, zdtemp2, zatempprime
+
+      REAL(wp), PARAMETER ::   ppkfriction = 0.45_wp
       ! Factor to maintain the same stress as in EVP (see Section 3)
       ! Can be set to 1 otherwise
-!      zinvstressconviso = 1._wp/(1._wp+kfriction*kfriction)
-      zinvstressconviso = 1._wp
- 
-      zinvsin = 1._wp/sin(2._wp*pphi) * zinvstressconviso 
-      !now uses phi as set in higher code
-       
+!     REAL(wp), PARAMETER ::   ppinvstressconviso = 1._wp/(1._wp+ppkfriction*ppkfriction)
+      REAL(wp), PARAMETER ::   ppinvstressconviso = 1._wp
+
+      ! next statement uses pphi set in main module (icedyn_rhg_eap)
+      REAL(wp), PARAMETER ::   ppinvsin = 1._wp/sin(2._wp*pphi) * ppinvstressconviso
+
       ! compute eigenvalues, eigenvectors and angles for structure tensor, strain
       ! rates
@@ -1132,22 +1138,22 @@
       zQ12Q12 = rsmall
       zQ11Q12 = rsmall
- 
-      ! gamma: angle between general coordiantes and principal axis of A 
-      ! here Tan2gamma = 2 a12 / (a11 - a22) 
-      IF((ABS(pa11 - za22) > rsmall).OR.(ABS(pa12) > rsmall)) THEN      
+
+      ! gamma: angle between general coordiantes and principal axis of A
+      ! here Tan2gamma = 2 a12 / (a11 - a22)
+      IF((ABS(pa11 - za22) > rsmall).OR.(ABS(pa12) > rsmall)) THEN
          zAngle_denom_gamma = 1._wp/sqrt( ( pa11 - za22 )*( pa11 - za22) + &
                               4._wp*pa12*pa12 )
-   
-         zQ11Q11 = 0.5_wp + ( pa11 - za22 )*0.5_wp*zAngle_denom_gamma   !Cos^2 
+
+         zQ11Q11 = 0.5_wp + ( pa11 - za22 )*0.5_wp*zAngle_denom_gamma   !Cos^2
          zQ12Q12 = 0.5_wp - ( pa11 - za22 )*0.5_wp*zAngle_denom_gamma   !Sin^2
-         zQ11Q12 = pa12*zAngle_denom_gamma                     !CosSin 
-      ENDIF
- 
+         zQ11Q12 = pa12*zAngle_denom_gamma                     !CosSin
+      ENDIF
+
       ! rotation Q*atemp*Q^T
-      zatempprime = zQ11Q11*pa11 + 2.0_wp*zQ11Q12*pa12 + zQ12Q12*za22 
-      
+      zatempprime = zQ11Q11*pa11 + 2.0_wp*zQ11Q12*pa12 + zQ12Q12*za22
+
       ! make first principal value the largest
       zatempprime = max(zatempprime, 1.0_wp - zatempprime)
- 
+
       ! 2) strain rate
       zdtemp11 = 0.5_wp*(pdivu + ptension)
@@ -1155,5 +1161,5 @@
       zdtemp22 = 0.5_wp*(pdivu - ptension)
 
-      ! here Tan2alpha = 2 dtemp12 / (dtemp11 - dtemp22) 
+      ! here Tan2alpha = 2 dtemp12 / (dtemp11 - dtemp22)
 
       zQd11Qd11 = 1.0_wp
@@ -1166,5 +1172,5 @@
                              ( zdtemp11 - zdtemp22 ) + 4.0_wp*zdtemp12*zdtemp12)
 
-         zQd11Qd11 = 0.5_wp + ( zdtemp11 - zdtemp22 )*0.5_wp*zAngle_denom_alpha !Cos^2 
+         zQd11Qd11 = 0.5_wp + ( zdtemp11 - zdtemp22 )*0.5_wp*zAngle_denom_alpha !Cos^2
          zQd12Qd12 = 0.5_wp - ( zdtemp11 - zdtemp22 )*0.5_wp*zAngle_denom_alpha !Sin^2
          zQd11Qd12 = zdtemp12*zAngle_denom_alpha !CosSin
@@ -1177,35 +1183,32 @@
       IF ((ABS(zdtemp1) > rsmall).OR.(ABS(zdtemp2) > rsmall)) THEN
          zx = atan2(zdtemp2,zdtemp1)
-      ENDIF      
-               
-      ! to ensure the angle lies between pi/4 and 9 pi/4 
+      ENDIF
+
+      ! to ensure the angle lies between pi/4 and 9 pi/4
       IF (zx < rpi*0.25_wp) zx = zx + rpi*2.0_wp
-      
+
       ! y: angle between major principal axis of strain rate and structure
       ! tensor
-      ! y = gamma - alpha 
+      ! y = gamma - alpha
       ! Expressesed componently with
       ! Tany = (Singamma*Cosgamma - Sinalpha*Cosgamma)/(Cos^2gamma - Sin^alpha)
-      
+
       zTany_1 = zQ11Q12 - zQd11Qd12
       zTany_2 = zQ11Q11 - zQd12Qd12
-      
+
       zy = 0._wp
-      
+
       IF ((ABS(zTany_1) > rsmall).OR.(ABS(zTany_2) > rsmall)) THEN
          zy = atan2(zTany_1,zTany_2)
       ENDIF
-      
+
       ! to make sure y is between 0 and pi
       IF (zy > rpi) zy = zy - rpi
       IF (zy < 0)  zy = zy + rpi
 
-      ! 3) update anisotropic stress tensor 
-      zdx   = rpi/real(nx_yield-1,kind=wp)
-      zdy   = rpi/real(ny_yield-1,kind=wp)
-      zda   = 0.5_wp/real(na_yield-1,kind=wp)
-      zinvdx = 1._wp/zdx
-      zinvdy = 1._wp/zdy
-      zinvda = 1._wp/zda
+      ! 3) update anisotropic stress tensor
+      zinvdx = real(nx_yield-1,kind=wp)/rpi
+      zinvdy = real(ny_yield-1,kind=wp)/rpi
+      zinvda = 2._wp*real(na_yield-1,kind=wp)
 
       ! % need 8 coords and 8 weights
@@ -1213,14 +1216,14 @@
       kx  = int((zx-rpi*0.25_wp-rpi)*zinvdx) + 1
       !!clem kx  = MAX( 1, MIN( nx_yield-1, INT((zx-rpi*0.25_wp-rpi)*zinvdx) + 1  ) )
-      zkxw = kx - (zx-rpi*0.25_wp-rpi)*zinvdx  
-      
+      zkxw = kx - (zx-rpi*0.25_wp-rpi)*zinvdx
+
       ky  = int(zy*zinvdy) + 1
       !!clem ky  = MAX( 1, MIN( ny_yield-1, INT(zy*zinvdy) + 1 ) )
-      kyw = ky - zy*zinvdy 
-      
+      kyw = ky - zy*zinvdy
+
       ka  = int((zatempprime-0.5_wp)*zinvda) + 1
       !!clem ka  = MAX( 1, MIN( na_yield-1, INT((zatempprime-0.5_wp)*zinvda) + 1 ) )
       kaw = ka - (zatempprime-0.5_wp)*zinvda
-      
+
       ! % Determine sigma_r(A1,Zeta,y) and sigma_s (see Section A1 of Tsamados 2013)
 !!$      zstemp11r =  zkxw  * kyw         * kaw         * s11r(kx  ,ky  ,ka  ) &
@@ -1248,5 +1251,5 @@
 !!$        & + zkxw         * (1._wp-kyw) * (1._wp-kaw) * s22r(kx  ,ky+1,ka+1) &
 !!$        & + (1._wp-zkxw) * (1._wp-kyw) * (1._wp-kaw) * s22r(kx+1,ky+1,ka+1)
-!!$      
+!!$
 !!$      zstemp11s =  zkxw  * kyw         * kaw         * s11s(kx  ,ky  ,ka  ) &
 !!$        & + (1._wp-zkxw) * kyw         * kaw         * s11s(kx+1,ky  ,ka  ) &
@@ -1280,12 +1283,12 @@
       zstemp12s = s12s(kx,ky,ka)
       zstemp22s = s22s(kx,ky,ka)
-      
-      
+
+
       ! Calculate mean ice stress over a collection of floes (Equation 3 in
       ! Tsamados 2013)
 
-      zsig11  = pstrength*(zstemp11r + kfriction*zstemp11s) * zinvsin
-      zsig12  = pstrength*(zstemp12r + kfriction*zstemp12s) * zinvsin
-      zsig22  = pstrength*(zstemp22r + kfriction*zstemp22s) * zinvsin
+      zsig11  = pstrength*(zstemp11r + ppkfriction*zstemp11s) * ppinvsin
+      zsig12  = pstrength*(zstemp12r + ppkfriction*zstemp12s) * ppinvsin
+      zsig22  = pstrength*(zstemp22r + ppkfriction*zstemp22s) * ppinvsin
 
       ! Back - rotation of the stress from principal axes into general coordinates
@@ -1300,5 +1303,5 @@
       pstressm  = zsgprm11 - zsgprm22
 
-      ! Compute ridging and sliding functions in general coordinates 
+      ! Compute ridging and sliding functions in general coordinates
       ! (Equation 11 in Tsamados 2013)
       IF (ksub == kndte) THEN
@@ -1307,5 +1310,5 @@
          zrotstemp12r = zQ11Q11*zstemp12r +       zQ11Q12*(zstemp11r-zstemp22r) &
                       - zQ12Q12*zstemp12r
-         zrotstemp22r = zQ12Q12*zstemp11r + 2._wp*zQ11Q12* zstemp12r & 
+         zrotstemp22r = zQ12Q12*zstemp11r + 2._wp*zQ11Q12* zstemp12r &
                       + zQ11Q11*zstemp22r
 
@@ -1314,5 +1317,5 @@
          zrotstemp12s = zQ11Q11*zstemp12s +       zQ11Q12*(zstemp11s-zstemp22s) &
                       - zQ12Q12*zstemp12s
-         zrotstemp22s = zQ12Q12*zstemp11s + 2._wp*zQ11Q12* zstemp12s & 
+         zrotstemp22s = zQ12Q12*zstemp11s + 2._wp*zQ11Q12* zstemp12s &
                       + zQ11Q11*zstemp22s
 
@@ -1322,5 +1325,5 @@
                   + zrotstemp22s*zdtemp22
       ENDIF
-   END SUBROUTINE update_stress_rdg 
+   END SUBROUTINE update_stress_rdg
 
 !=======================================================================
@@ -1331,5 +1334,5 @@
       !!---------------------------------------------------------------------
       !!                   ***  ROUTINE calc_ffrac  ***
-      !!                     
+      !!
       !! ** Purpose :   Computes term in evolution equation for structure tensor
       !!                which determines the ice floe re-orientation due to fracture
@@ -1346,20 +1349,20 @@
       REAL (wp) ::   zQ11, zQ12, zQ11Q11, zQ11Q12, zQ12Q12
 
-!!$      REAL (wp), PARAMETER ::   kfrac = 0.0001_wp   ! rate of fracture formation 
-      REAL (wp), PARAMETER ::   kfrac = 1.e-3_wp   ! rate of fracture formation 
-      REAL (wp), PARAMETER ::   threshold = 0.3_wp  ! critical confinement ratio 
+!!$   REAL (wp), PARAMETER ::   ppkfrac = 0.0001_wp   ! rate of fracture formation
+      REAL (wp), PARAMETER ::   ppkfrac = 1.e-3_wp    ! rate of fracture formation
+      REAL (wp), PARAMETER ::   ppthreshold = 0.3_wp  ! critical confinement ratio
       !!---------------------------------------------------------------
       !
-      zsigma11 = 0.5_wp*(pstressp+pstressm) 
-      zsigma12 = pstress12 
-      zsigma22 = 0.5_wp*(pstressp-pstressm) 
+      zsigma11 = 0.5_wp*(pstressp+pstressm)
+      zsigma12 = pstress12
+      zsigma22 = 0.5_wp*(pstressp-pstressm)
 
       ! Here's the change - no longer calculate gamma,
       ! use trig formulation, angle signs are kept correct, don't worry
-   
+
       ! rotate tensor to get into sigma principal axis
-   
-      ! here Tan2gamma = 2 sig12 / (sig11 - sig12) 
-      ! add rsmall to the denominator to stop 1/0 errors, makes very little 
+
+      ! here Tan2gamma = 2 sig12 / (sig11 - sig12)
+      ! add rsmall to the denominator to stop 1/0 errors, makes very little
       ! error to the calculated angles < rsmall
 
@@ -1373,7 +1376,7 @@
                        zsigma22 ) + 4.0_wp*zsigma12*zsigma12)
 
-         zQ11Q11 = 0.5_wp + ( zsigma11 - zsigma22 )*0.5_wp*zAngle_denom   !Cos^2 
+         zQ11Q11 = 0.5_wp + ( zsigma11 - zsigma22 )*0.5_wp*zAngle_denom   !Cos^2
          zQ12Q12 = 0.5_wp - ( zsigma11 - zsigma22 )*0.5_wp*zAngle_denom   !Sin^2
-         zQ11Q12 = zsigma12*zAngle_denom                      !CosSin 
+         zQ11Q12 = zsigma12*zAngle_denom                      !CosSin
       ENDIF
 
@@ -1390,6 +1393,6 @@
       ! which leads to the loss of their shape, so we again model it through diffusion
       ELSEIF ((zsigma_1 >= 0.0_wp).AND.(zsigma_2 < 0.0_wp))  THEN
-         pmresult11 = - kfrac * (pa11 - zQ12Q12)
-         pmresult12 = - kfrac * (pa12 + zQ11Q12)
+         pmresult11 = - ppkfrac * (pa11 - zQ12Q12)
+         pmresult12 = - ppkfrac * (pa12 + zQ11Q12)
 
       ! Shear faulting
@@ -1397,10 +1400,10 @@
          pmresult11 = 0.0_wp
          pmresult12 = 0.0_wp
-      ELSEIF ((zsigma_1 <= 0.0_wp).AND.(zsigma_1/zsigma_2 <= threshold)) THEN
-         pmresult11 = - kfrac * (pa11 - zQ12Q12)
-         pmresult12 = - kfrac * (pa12 + zQ11Q12)
+      ELSEIF ((zsigma_1 <= 0.0_wp).AND.(zsigma_1/zsigma_2 <= ppthreshold)) THEN
+         pmresult11 = - ppkfrac * (pa11 - zQ12Q12)
+         pmresult12 = - ppkfrac * (pa12 + zQ11Q12)
 
       ! Horizontal spalling
-      ELSE 
+      ELSE
          pmresult11 = 0.0_wp
          pmresult12 = 0.0_wp
@@ -1413,7 +1416,7 @@
       !!---------------------------------------------------------------------
       !!                   ***  ROUTINE rhg_eap_rst  ***
-      !!                     
+      !!
       !! ** Purpose :   Read or write RHG file in restart file
-      !!      
+      !!
       !! ** Method  :   use of IOM library
       !!----------------------------------------------------------------------
@@ -1424,7 +1427,7 @@
       INTEGER  ::   id1, id2, id3, id4, id5   ! local integers
       INTEGER  ::   ix, iy, ip, iz, n, ia     ! local integers
-    
+
       INTEGER, PARAMETER            ::    nz = 100
-      
+
       REAL(wp) ::   ainit, xinit, yinit, pinit, zinit
       REAL(wp) ::   da, dx, dy, dp, dz, a1
@@ -1432,5 +1435,6 @@
       !!clem
       REAL(wp) ::   zw1, zw2, zfac, ztemp
-      REAL(wp) ::   idx, idy, idz
+      REAL(wp) ::   zidx, zidy, zidz
+      REAL(wp) ::   zsaak(6)                  ! temporary array
 
       REAL(wp), PARAMETER           ::   eps6 = 1.0e-6_wp
@@ -1508,5 +1512,5 @@
 !!$                        s22r(ix,iy,ia) = s22r(ix,iy,ia) + 1*w1(ainit+ia*da)* &
 !!$                           exp(-w2(ainit+ia*da)*(zinit+iz*dz)*(zinit+iz*dz))* &
-!!$                           s22kr(xinit+ix*dx,yinit+iy*dy,zinit+iz*dz)*dz/sin(2._wp*pphi) 
+!!$                           s22kr(xinit+ix*dx,yinit+iy*dy,zinit+iz*dz)*dz/sin(2._wp*pphi)
 !!$                        s11s(ix,iy,ia) = s11s(ix,iy,ia) + 1*w1(ainit+ia*da)* &
 !!$                           exp(-w2(ainit+ia*da)*(zinit+iz*dz)*(zinit+iz*dz))* &
@@ -1543,5 +1547,5 @@
 !!$         ENDDO
 
-         !! faster but still very slow => to be improved         
+         !! faster but still very slow => to be improved
          zfac = dz/sin(2._wp*pphi)
          DO ia = 1, na_yield-1
@@ -1549,33 +1553,36 @@
             zw2 = w2(ainit+ia*da)
             DO iz = 1, nz
-               idz = zinit+iz*dz
+               zidz = zinit+iz*dz
                ztemp = zw1 * EXP(-zw2*(zinit+iz*dz)*(zinit+iz*dz))
                DO iy = 1, ny_yield
-                  idy = yinit+iy*dy
+                  zidy = yinit+iy*dy
                   DO ix = 1, nx_yield
-                     idx = xinit+ix*dx
-                     s11r(ix,iy,ia) = s11r(ix,iy,ia) + ztemp * s11kr(idx,idy,idz)*zfac
-                     s12r(ix,iy,ia) = s12r(ix,iy,ia) + ztemp * s12kr(idx,idy,idz)*zfac
-                     s22r(ix,iy,ia) = s22r(ix,iy,ia) + ztemp * s22kr(idx,idy,idz)*zfac 
-                     s11s(ix,iy,ia) = s11s(ix,iy,ia) + ztemp * s11ks(idx,idy,idz)*zfac
-                     s12s(ix,iy,ia) = s12s(ix,iy,ia) + ztemp * s12ks(idx,idy,idz)*zfac
-                     s22s(ix,iy,ia) = s22s(ix,iy,ia) + ztemp * s22ks(idx,idy,idz)*zfac
+                     zidx = xinit+ix*dx
+                     call all_skr_sks(zidx,zidy,zidz,zsaak)
+                     zsaak = ztemp*zsaak*zfac
+                     s11r(ix,iy,ia) = s11r(ix,iy,ia) + zsaak(1)
+                     s12r(ix,iy,ia) = s12r(ix,iy,ia) + zsaak(2)
+                     s22r(ix,iy,ia) = s22r(ix,iy,ia) + zsaak(3)
+                     s11s(ix,iy,ia) = s11s(ix,iy,ia) + zsaak(4)
+                     s12s(ix,iy,ia) = s12s(ix,iy,ia) + zsaak(5)
+                     s22s(ix,iy,ia) = s22s(ix,iy,ia) + zsaak(6)
                   END DO
                END DO
             END DO
          END DO
-
          zfac = 1._wp/sin(2._wp*pphi)
          ia = na_yield
          DO iy = 1, ny_yield
-            idy = yinit+iy*dy
+            zidy = yinit+iy*dy
             DO ix = 1, nx_yield
-               idx = xinit+ix*dx                  
-               s11r(ix,iy,ia) = 0.5_wp*s11kr(idx,idy,0._wp)*zfac
-               s12r(ix,iy,ia) = 0.5_wp*s12kr(idx,idy,0._wp)*zfac
-               s22r(ix,iy,ia) = 0.5_wp*s22kr(idx,idy,0._wp)*zfac
-               s11s(ix,iy,ia) = 0.5_wp*s11ks(idx,idy,0._wp)*zfac
-               s12s(ix,iy,ia) = 0.5_wp*s12ks(idx,idy,0._wp)*zfac
-               s22s(ix,iy,ia) = 0.5_wp*s22ks(idx,idy,0._wp)*zfac
+               zidx = xinit+ix*dx
+               call all_skr_sks(zidx,zidy,0._wp,zsaak)
+               zsaak = 0.5_wp*zsaak*zfac
+               s11r(ix,iy,ia) = zsaak(1)
+               s12r(ix,iy,ia) = zsaak(2)
+               s22r(ix,iy,ia) = zsaak(3)
+               s11s(ix,iy,ia) = zsaak(4)
+               s12s(ix,iy,ia) = zsaak(5)
+               s22s(ix,iy,ia) = zsaak(6)
             ENDDO
          ENDDO
@@ -1611,5 +1618,5 @@
       REAL(wp) ::   w1
       !!-------------------------------------------------------------------
-   
+
       w1 = -   223.87569446_wp &
        &   +  2361.21986630_wp*pa &
@@ -1620,5 +1627,5 @@
        &   - 16789.98003081_wp*pa*pa*pa*pa*pa*pa &
        &   +  3495.82839237_wp*pa*pa*pa*pa*pa*pa*pa
-   
+
    END FUNCTION w1
 
@@ -1631,5 +1638,5 @@
       REAL(wp) ::   w2
       !!-------------------------------------------------------------------
-   
+
       w2 = -    6670.68911883_wp &
        &   +   70222.33061536_wp*pa &
@@ -1640,15 +1647,15 @@
        &   -  493379.44906738_wp*pa*pa*pa*pa*pa*pa &
        &   +  102356.55151800_wp*pa*pa*pa*pa*pa*pa*pa
-   
+
    END FUNCTION w2
 
-   FUNCTION s11kr(px,py,pz) 
-      !!-------------------------------------------------------------------
-      !! Function : s11kr
-      !!-------------------------------------------------------------------
+   SUBROUTINE all_skr_sks( px, py, pz, allsk )
       REAL(wp), INTENT(in   ) ::   px,py,pz
-   
-      REAL(wp) ::   s11kr, zpih
-   
+      REAL(wp), INTENT(out  ) ::   allsk(6)
+
+      REAL(wp) ::   zs12r0, zs21r0
+      REAL(wp) ::   zs12s0, zs21s0
+
+      REAL(wp) ::   zpih
       REAL(wp) ::   zn1t2i11, zn1t2i12, zn1t2i21, zn1t2i22
       REAL(wp) ::   zn2t1i11, zn2t1i12, zn2t1i21, zn2t1i22
@@ -1659,7 +1666,7 @@
       REAL(wp) ::   zHen1t2, zHen2t1
       !!-------------------------------------------------------------------
-   
+
       zpih = 0.5_wp*rpi
-   
+
       zn1t2i11 = cos(pz+zpih-pphi) * cos(pz+pphi)
       zn1t2i12 = cos(pz+zpih-pphi) * sin(pz+pphi)
@@ -1687,5 +1694,5 @@
       zIIn2t1 = zn2t1i11 * zd11 + (zn2t1i12 + zn2t1i21) * zd12 + zn2t1i22 * zd22
       zIIt1t2 = zt1t2i11 * zd11 + (zt1t2i12 + zt1t2i21) * zd12 + zt1t2i22 * zd22
-   
+
       IF (-zIIn1t2>=rsmall) THEN
       zHen1t2 = 1._wp
@@ -1693,5 +1700,5 @@
       zHen1t2 = 0._wp
       ENDIF
-   
+
       IF (-zIIn2t1>=rsmall) THEN
       zHen2t1 = 1._wp
